// -*- C++ -*-
/*!
 * @file  MyServiceConsumer.cpp
 * @brief MyService Consumer Sample component
 * $Date$
 *
 * $Id$
 */

#include "MyServiceConsumer.h"

// Module specification
// <rtc-template block="module_spec">
static const char* myserviceconsumer_spec[] =
  {
    "implementation_id", "MyServiceConsumer",
    "type_name",         "MyServiceConsumer",
    "description",       "MyService Consumer Sample component",
    "version",           "0.1",
    "vendor",            "AIST",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

MyServiceConsumer::MyServiceConsumer(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    //m_RQPort("RQ"),m_RPPort("RP"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  //m_RPPort.registerProvider("callback0", "RP", m_callback0);
  
  // Set service consumers to Ports
  //m_RQPort.registerConsumer("myservice0", "RQ", m_myservice0);
  
  // Set CORBA Service Ports
  //registerPort(m_RQPort);
  //registerPort(m_RPPort);
  
  // </rtc-template>

}

MyServiceConsumer::~MyServiceConsumer()
{
}


RTC::ReturnCode_t MyServiceConsumer::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  addPort();
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t MyServiceConsumer::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceConsumer::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t MyServiceConsumer::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t MyServiceConsumer::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceConsumer::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t MyServiceConsumer::onExecute(RTC::UniqueId ec_id)
{
	for(unsigned long i(0); i < m_request.size() ;i++)
	{
		if( m_request[i].requestflag == 0)
		{
			 m_request[i].requestflag++;
			 std::cout << "Port[" << i << "] Request : flag = 0"  << std::endl;
		}

		if( m_reply[i]->isReply() == 0)
		{
			//m_request[i]->setReplyFlag(m_reply[i]->isReply()+1)
			std::cout << "Port[" << i << "] Reply : flag = 0" << std::endl;
		}

	}

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t MyServiceConsumer::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceConsumer::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceConsumer::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceConsumer::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceConsumer::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

void MyServiceConsumer::addPort()
{
	std::string portName("IDServicePort");
	std::string requestName("requestID");
	std::string provideName("providerID");

	portName += otos(dynamicPortCounter);
	requestName += otos(dynamicPortCounter);
	provideName += otos(dynamicPortCounter);

	//provider port
	RQSVC_impl tmpRequest;
	m_request.push_back(tmpRequest);

	//consumer port
	RTC::CorbaConsumer<RP> tmpReply;
	m_reply.push_back(tmpReply);

	//regist port
	m_ServicePort.push_back(new RTC::CorbaPort(portName.c_str()));
	m_ServicePort.back()->registerProvider( requestName.c_str() , requestName.c_str() , m_request.back());
	m_ServicePort.back()->registerConsumer( provideName.c_str() , provideName.c_str() , m_reply.back()  );
	//registing port
	registerPort(*m_ServicePort.back());

	dynamicPortCounter++;

}

extern "C"
{
 
  void MyServiceConsumerInit(RTC::Manager* manager)
  {
    RTC::Properties profile(myserviceconsumer_spec);
    manager->registerFactory(profile,
                             RTC::Create<MyServiceConsumer>,
                             RTC::Delete<MyServiceConsumer>);
  }
  
};


