// -*-C++-*-
/*!
 * @file  serviceSVC_impl.h
 * @brief Service implementation header of service.idl
 *
 */

#include "serviceSkel.h"


#ifndef SERVICESVC_IMPL_H
#define SERVICESVC_IMPL_H
 
/*
 * Example class implementing IDL interface RQ
 */
class RQSVC_impl
 : public virtual POA_RQ,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~RQSVC_impl();

 public:
   // standard constructor
   RQSVC_impl();
   virtual ~RQSVC_impl();
   long requestflag;
   // attributes and operations
   void request();
   CORBA::Short isRequest();
   void setRequest(CORBA::Short flag);
};

/*
 * Example class implementing IDL interface RP
 */
class RPSVC_impl
 : public virtual POA_RP,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~RPSVC_impl();

 public:
   // standard constructor
   RPSVC_impl();
   virtual ~RPSVC_impl();
   long replyflag;
   // attributes and operations
   void reply();
   CORBA::Short isReply();
   void setReplyFlag(CORBA::Short flag);
};



#endif // SERVICESVC_IMPL_H


